needs_pass = True

caesar_dict = {}
for i in range(26):
    caesar_dict['abcdefghijklmnopqrstuvwxyz'[i]] = i

normal_dict = {}
for i in range(26):
    normal_dict[i] = 'abcdefghijklmnopqrstuvwxyz'[i]

def encode(text, password):
    text = text.lower()
    encode_text = ''
    pas_count = 0
    for letter in text:
        if letter not in caesar_dict:
            encode_text += letter
            continue
        if pas_count == len(password):
            pas_count = 0
        letternumber = caesar_dict[letter]
        new_letter = letternumber+caesar_dict[password.lower()[pas_count]]
        if new_letter > 25:
            new_letter -= 26
        encode_text += normal_dict[new_letter]
        pas_count += 1
    return encode_text

def decode(text, password):
    text = text.lower()
    decode_text = ''
    pas_count = 0
    for letter in text:
        if letter not in caesar_dict:
            decode_text += letter
            continue
        if pas_count == len(password):
            pas_count = 0
        letternumber = caesar_dict[letter]
        old_letter = letternumber-caesar_dict[password.lower()[pas_count]]
        if old_letter < 0:
            old_letter += 26
        decode_text += normal_dict[old_letter]
        pas_count += 1
    return decode_text

