needs_pass = False

normal = '!"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~'
encodet = 'PQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~!"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNO'

rot47_dict = {}
for i in range(94):
    rot47_dict[normal[i]] = encodet[i]

def encode(text):
    encode_text = ''
    for char in text:
        if char not in rot47_dict:
            encode_text += char
            continue
        encode_text += rot47_dict[char]
        
    return encode_text

def decode(text):
    decode_text = ''
    for char in text:
        if char not in rot47_dict:
            decode_text += char
            continue
        decode_text += rot47_dict[char]

    return decode_text
